# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class EmailBinariesListInner(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'binaries': 'list[FileObject]',
        'categories': 'list[EmailBinariesListInnerCategories]',
        'families': 'list[EmailBinariesListInnerFamilies]',
        'page_index': 'float'
    }

    attribute_map = {
        'binaries': 'binaries',
        'categories': 'categories',
        'families': 'families',
        'page_index': 'page_index'
    }

    def __init__(self, binaries=None, categories=None, families=None, page_index=None):  # noqa: E501
        """EmailBinariesListInner - a model defined in Swagger"""  # noqa: E501

        self._binaries = None
        self._categories = None
        self._families = None
        self._page_index = None
        self.discriminator = None

        if binaries is not None:
            self.binaries = binaries
        if categories is not None:
            self.categories = categories
        if families is not None:
            self.families = families
        if page_index is not None:
            self.page_index = page_index

    @property
    def binaries(self):
        """Gets the binaries of this EmailBinariesListInner.  # noqa: E501


        :return: The binaries of this EmailBinariesListInner.  # noqa: E501
        :rtype: list[FileObject]
        """
        return self._binaries

    @binaries.setter
    def binaries(self, binaries):
        """Sets the binaries of this EmailBinariesListInner.


        :param binaries: The binaries of this EmailBinariesListInner.  # noqa: E501
        :type: list[FileObject]
        """

        self._binaries = binaries

    @property
    def categories(self):
        """Gets the categories of this EmailBinariesListInner.  # noqa: E501


        :return: The categories of this EmailBinariesListInner.  # noqa: E501
        :rtype: list[EmailBinariesListInnerCategories]
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this EmailBinariesListInner.


        :param categories: The categories of this EmailBinariesListInner.  # noqa: E501
        :type: list[EmailBinariesListInnerCategories]
        """

        self._categories = categories

    @property
    def families(self):
        """Gets the families of this EmailBinariesListInner.  # noqa: E501


        :return: The families of this EmailBinariesListInner.  # noqa: E501
        :rtype: list[EmailBinariesListInnerFamilies]
        """
        return self._families

    @families.setter
    def families(self, families):
        """Sets the families of this EmailBinariesListInner.


        :param families: The families of this EmailBinariesListInner.  # noqa: E501
        :type: list[EmailBinariesListInnerFamilies]
        """

        self._families = families

    @property
    def page_index(self):
        """Gets the page_index of this EmailBinariesListInner.  # noqa: E501


        :return: The page_index of this EmailBinariesListInner.  # noqa: E501
        :rtype: float
        """
        return self._page_index

    @page_index.setter
    def page_index(self, page_index):
        """Sets the page_index of this EmailBinariesListInner.


        :param page_index: The page_index of this EmailBinariesListInner.  # noqa: E501
        :type: float
        """

        self._page_index = page_index

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EmailBinariesListInner, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EmailBinariesListInner):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
