# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 0.33.9
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class EmailDataListInner(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sha1': 'Sha1',
        'from_acc': 'str',
        'from_addr': 'str',
        'to_acc': 'str',
        'to_addr': 'str',
        'other_addrs': 'list[str]',
        'subject': 'str',
        'department': 'str',
        'id': 'str',
        'ioc_objects': 'list[str]',
        'attachment_files': 'list[str]',
        'email_children': 'list[str]'
    }

    attribute_map = {
        'sha1': 'sha1',
        'from_acc': 'from_acc',
        'from_addr': 'from_addr',
        'to_acc': 'to_acc',
        'to_addr': 'to_addr',
        'other_addrs': 'other_addrs',
        'subject': 'subject',
        'department': 'department',
        'id': 'id',
        'ioc_objects': 'ioc_objects',
        'attachment_files': 'attachment_files',
        'email_children': 'email_children'
    }

    def __init__(self, sha1=None, from_acc=None, from_addr=None, to_acc=None, to_addr=None, other_addrs=None, subject=None, department=None, id=None, ioc_objects=None, attachment_files=None, email_children=None):  # noqa: E501
        """EmailDataListInner - a model defined in Swagger"""  # noqa: E501

        self._sha1 = None
        self._from_acc = None
        self._from_addr = None
        self._to_acc = None
        self._to_addr = None
        self._other_addrs = None
        self._subject = None
        self._department = None
        self._id = None
        self._ioc_objects = None
        self._attachment_files = None
        self._email_children = None
        self.discriminator = None

        if sha1 is not None:
            self.sha1 = sha1
        if from_acc is not None:
            self.from_acc = from_acc
        if from_addr is not None:
            self.from_addr = from_addr
        if to_acc is not None:
            self.to_acc = to_acc
        if to_addr is not None:
            self.to_addr = to_addr
        if other_addrs is not None:
            self.other_addrs = other_addrs
        if subject is not None:
            self.subject = subject
        if department is not None:
            self.department = department
        if id is not None:
            self.id = id
        if ioc_objects is not None:
            self.ioc_objects = ioc_objects
        if attachment_files is not None:
            self.attachment_files = attachment_files
        if email_children is not None:
            self.email_children = email_children

    @property
    def sha1(self):
        """Gets the sha1 of this EmailDataListInner.  # noqa: E501


        :return: The sha1 of this EmailDataListInner.  # noqa: E501
        :rtype: Sha1
        """
        return self._sha1

    @sha1.setter
    def sha1(self, sha1):
        """Sets the sha1 of this EmailDataListInner.


        :param sha1: The sha1 of this EmailDataListInner.  # noqa: E501
        :type: Sha1
        """

        self._sha1 = sha1

    @property
    def from_acc(self):
        """Gets the from_acc of this EmailDataListInner.  # noqa: E501

        The original receiver of the email  # noqa: E501

        :return: The from_acc of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._from_acc

    @from_acc.setter
    def from_acc(self, from_acc):
        """Sets the from_acc of this EmailDataListInner.

        The original receiver of the email  # noqa: E501

        :param from_acc: The from_acc of this EmailDataListInner.  # noqa: E501
        :type: str
        """
        if from_acc is not None and not re.search(r'.+@.+', from_acc):  # noqa: E501
            raise ValueError(r"Invalid value for `from_acc`, must be a follow pattern or equal to `/.+@.+/`")  # noqa: E501

        self._from_acc = from_acc

    @property
    def from_addr(self):
        """Gets the from_addr of this EmailDataListInner.  # noqa: E501

        The receiver of the email  # noqa: E501

        :return: The from_addr of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._from_addr

    @from_addr.setter
    def from_addr(self, from_addr):
        """Sets the from_addr of this EmailDataListInner.

        The receiver of the email  # noqa: E501

        :param from_addr: The from_addr of this EmailDataListInner.  # noqa: E501
        :type: str
        """
        if from_addr is not None and not re.search(r'.+@.+', from_addr):  # noqa: E501
            raise ValueError(r"Invalid value for `from_addr`, must be a follow pattern or equal to `/.+@.+/`")  # noqa: E501

        self._from_addr = from_addr

    @property
    def to_acc(self):
        """Gets the to_acc of this EmailDataListInner.  # noqa: E501

        The original sender of the email  # noqa: E501

        :return: The to_acc of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._to_acc

    @to_acc.setter
    def to_acc(self, to_acc):
        """Sets the to_acc of this EmailDataListInner.

        The original sender of the email  # noqa: E501

        :param to_acc: The to_acc of this EmailDataListInner.  # noqa: E501
        :type: str
        """
        if to_acc is not None and not re.search(r'.+@.+', to_acc):  # noqa: E501
            raise ValueError(r"Invalid value for `to_acc`, must be a follow pattern or equal to `/.+@.+/`")  # noqa: E501

        self._to_acc = to_acc

    @property
    def to_addr(self):
        """Gets the to_addr of this EmailDataListInner.  # noqa: E501

        The sender of the email  # noqa: E501

        :return: The to_addr of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._to_addr

    @to_addr.setter
    def to_addr(self, to_addr):
        """Sets the to_addr of this EmailDataListInner.

        The sender of the email  # noqa: E501

        :param to_addr: The to_addr of this EmailDataListInner.  # noqa: E501
        :type: str
        """
        if to_addr is not None and not re.search(r'.+@.+', to_addr):  # noqa: E501
            raise ValueError(r"Invalid value for `to_addr`, must be a follow pattern or equal to `/.+@.+/`")  # noqa: E501

        self._to_addr = to_addr

    @property
    def other_addrs(self):
        """Gets the other_addrs of this EmailDataListInner.  # noqa: E501


        :return: The other_addrs of this EmailDataListInner.  # noqa: E501
        :rtype: list[str]
        """
        return self._other_addrs

    @other_addrs.setter
    def other_addrs(self, other_addrs):
        """Sets the other_addrs of this EmailDataListInner.


        :param other_addrs: The other_addrs of this EmailDataListInner.  # noqa: E501
        :type: list[str]
        """

        self._other_addrs = other_addrs

    @property
    def subject(self):
        """Gets the subject of this EmailDataListInner.  # noqa: E501

        The subject of the email  # noqa: E501

        :return: The subject of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._subject

    @subject.setter
    def subject(self, subject):
        """Sets the subject of this EmailDataListInner.

        The subject of the email  # noqa: E501

        :param subject: The subject of this EmailDataListInner.  # noqa: E501
        :type: str
        """

        self._subject = subject

    @property
    def department(self):
        """Gets the department of this EmailDataListInner.  # noqa: E501

        The department that this email was after  # noqa: E501

        :return: The department of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._department

    @department.setter
    def department(self, department):
        """Sets the department of this EmailDataListInner.

        The department that this email was after  # noqa: E501

        :param department: The department of this EmailDataListInner.  # noqa: E501
        :type: str
        """

        self._department = department

    @property
    def id(self):
        """Gets the id of this EmailDataListInner.  # noqa: E501

        The id string of the email object  # noqa: E501

        :return: The id of this EmailDataListInner.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this EmailDataListInner.

        The id string of the email object  # noqa: E501

        :param id: The id of this EmailDataListInner.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def ioc_objects(self):
        """Gets the ioc_objects of this EmailDataListInner.  # noqa: E501


        :return: The ioc_objects of this EmailDataListInner.  # noqa: E501
        :rtype: list[str]
        """
        return self._ioc_objects

    @ioc_objects.setter
    def ioc_objects(self, ioc_objects):
        """Sets the ioc_objects of this EmailDataListInner.


        :param ioc_objects: The ioc_objects of this EmailDataListInner.  # noqa: E501
        :type: list[str]
        """

        self._ioc_objects = ioc_objects

    @property
    def attachment_files(self):
        """Gets the attachment_files of this EmailDataListInner.  # noqa: E501


        :return: The attachment_files of this EmailDataListInner.  # noqa: E501
        :rtype: list[str]
        """
        return self._attachment_files

    @attachment_files.setter
    def attachment_files(self, attachment_files):
        """Sets the attachment_files of this EmailDataListInner.


        :param attachment_files: The attachment_files of this EmailDataListInner.  # noqa: E501
        :type: list[str]
        """

        self._attachment_files = attachment_files

    @property
    def email_children(self):
        """Gets the email_children of this EmailDataListInner.  # noqa: E501


        :return: The email_children of this EmailDataListInner.  # noqa: E501
        :rtype: list[str]
        """
        return self._email_children

    @email_children.setter
    def email_children(self, email_children):
        """Sets the email_children of this EmailDataListInner.


        :param email_children: The email_children of this EmailDataListInner.  # noqa: E501
        :type: list[str]
        """

        self._email_children = email_children

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EmailDataListInner, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EmailDataListInner):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
